
var audio = new window.AudioContext();
var partiture = "";
var playing = {};
var fading = {};
var wave = "sine";
var gains = {"low": 0.04, "medium": 0.1, "high": 0.3, "deaf": 0.6};
var cvol = "medium";

// Thank u leto
var KEYMAP = {
	"q": 40, "2": 41, "w": 42, "3": 43,
	"e": 44, "r": 45, "5": 46, "t": 47,
	"6": 48, "y": 49, "7": 50, "u": 51,
	"i": 52
}

function press(keycode) {

	if (keycode in KEYMAP) {
		document.getElementById("key_"+keycode).classList.add("pressed");
		key = KEYMAP[keycode];

		if (key in fading) {
			playing[key].oscillator.stop();
			delete playing[key];
			clearInterval(fading[key]);
			delete fading[key];
		} else if (key in playing) {
			return;
		}

		partiture += keycode;
		sheet.play(key);

		var oscillator = audio.createOscillator();
		var volume = audio.createGain();

		// https://en.wikipedia.org/wiki/Piano_key_frequencies
		// Yo I know nothing abot music I had to search it up on the wikipedias
		var frequency = Math.pow(1.0594630943592953, key-49)*440;

		volume.connect(audio.destination);
		volume.gain.value = gains[cvol];

		oscillator.type = wave;
		oscillator.frequency.value = frequency;
		oscillator.connect(volume);
		oscillator.start();

		playing[key] = {"oscillator": oscillator, "volume": volume};
	}

}

function release(keycode) {

	if (keycode in KEYMAP) {
		document.getElementById("key_"+keycode).classList.remove("pressed");
		key = KEYMAP[keycode];

		if (key in playing) {
			fading[key] = setInterval(fade, 60, key);
			function fade(key) {
				var note = playing[key];
				if (!note) {
					clearInterval(fading[key]);
				} else if (note.volume.gain.value <= 0) {
					note.oscillator.stop();
					delete playing[key];
					clearInterval(fading[key]);
					delete fading[key];
				} else {
					// Exponential fadeout
					note.volume.gain.value -= Math.max(note.volume.gain.value*.15, 0.0005);
				}
			}
		}
	}

	var song = partitures[partiture];
	if (song) {
		setTimeout(function(){
			window.location.href = song;
		}, 1000);
	} else {
		console.log(partiture);
	}

}

document.onkeydown = function(e) {
	press(e.key);
}
document.onkeyup = function(e) {
	release(e.key);
}
